'RMII Ethernet driver for the Propeller II

''''
''''
''''  THIS IS NOT YET READY '''


''' IT NEEDS DEBUGGING




'it was tested using the WaveShare LAN8720 and WaveShare DP83848 PHY breakout boards
'with pullups wired to the pins that select the MODE (we want the PHY to be in 100 mbit /full duplex / autoconfig mode)


' this software includes the SmartSerial.spin2 written by Eric R. Smith
' Copyright 2020 Total Spectrum Software Inc.
' Distributed under the MIT License (See LICENSE.md)



#ifndef _BAUD
#define _BAUD 230_400
#endif

CON  _xtlfreq = 25_000_000
  	 _clkfreq = 230_000_000
 	 baud = _BAUD
 
bufflongs = 640

OBJ
  ser: "spin/SmartSerial"

VAR
  BYTE name[128]
long a 

VAR buff[bufflongs]
VAR info[128]

VAR packet[bufflongs] 


PUB demo | i,j,k, xx, buffaddr, merker, zeile	' start ethernet code	
		
  ser.start(63, 62, 0, baud)
  'repeat
    ser.printf("Hello\n")

	buffaddr := @buff
	org
		wrlong #1, buffaddr
		end
		'wrfast #0, i
		
	packet[3] := $deadbabe
	packet[2] := $6bedbabe
	packet[0] := $00003333
	packet[1] := $aa00aaaa

	CogInit(COGEXEC_NEW, @ETHERNET_RX, @buff)
	CogInit(COGEXEC_NEW, @ETHERNET_TX, @packet)

	'waitms(2000)
repeat
	repeat i from 0 to 100
		if not merker == info[0]
			ser.printf("\ngood %x # bad %x - %x %x (%x)\n", info[0], info[1],info[2], info[3],info[4])

			repeat j from 0 to 15
				repeat k from 0 to 3
					ser.printf(" %x ", buff[k+(j*4)])
				ser.printf("\n")
				
			info[0] := 0 'signal to COG
			merker := info[0]
		waitms(10)
		if not rdpin(25) == zeile
			zeile := rdpin(25)
			ser.printf("%x,",zeile)


CON

	'in this setup i use two PHYs
	PHYa = 0 'lowest pin number of our PHY cable
	PHYb = 24 'lowest pin number of our PHY cable
	pin_SIG = 24+0 'just a signal for scoping
	
	' ethernet board RMII signals 
	pin_TX_EN =	PHYb+1 'push to send	
	pin_TX0 = 	PHYb+2 'transmit bit 0 and 1
	pin_TX1 = 	PHYb+3
	
	pin_CLK = PHYa+4 
	pin_RX0 = PHYa+5 'receive bit 0 and 1
	pin_RX1 = PHYa+6
	pin_CRS = PHYa+7 'carrier ready signal + frame RX signaling

	


DAT		ORG 'Each code block needs it's own DAT ORG

			CRC_TX long 0 '32 bit CRC (aka FCS)
			dwTX long 0 'dword to send (32 bit)
			wTX0 long 0 'split into odd & ..
			wTX1 long 0 '.. even bits (16 bit)
			ct long 0 'counter



ETHERNET_TX

		'DIRH #66 'debug channel
		'WRPIN  #P_REPOSITORY, #66
		'WXPIN #32, #66
 
		'events
		SETSE1  #%001<<6 + pin_TX_EN	'TX'd one word
				
		WRPIN  ##P_PLUS3_B	| P_INVERT_B	| P_SYNC_TX	| P_OE ,	#pin_TX_EN
  		WRPIN  ##P_PLUS2_B	| P_INVERT_B	| P_SYNC_TX	| P_OE ,	#pin_TX0
		WRPIN  ##P_PLUS1_B	| P_INVERT_B	| P_SYNC_TX	| P_OE ,	#pin_TX1
		WXPIN	#%0_01111 ,	#pin_TX_EN + (2 << 6) 'send out 16x2 bits at once (+ keep up TX_EN)


go		'start frame (including preamble)
		DIRL #pin_TX_EN + (2 << 6) 'stop smartpins
		mov ct, #10 'length (in dwords)
		mov CRC_TX, ##-1 'reset the CRC register

		RDFAST 	#24, PTRA 'start fetching the DATA
		
		waitx	##3000000_00 'Inter Frame Gap

		POLLSE1 'clear smartpin event		

		DIRH #pin_TX_EN + (2 << 6) 'start the action
		
		WYPIN ##$FF01, #pin_TX_EN 'drive the TX_EN line high synchronously with the data
		WYPIN ##$FF01, #pin_TX0 'channel 0 is all 1's (part of the preamble)
		WYPIN ##$0001, #pin_TX1
		
		waitx ##10

		
		'waitx #500 										
		'prepare the preamble, 6 bytes long, zero padded, LSB sent out first

		
		'WAITSE1
			
		'the other half
		WYPIN ##$FFFF, #pin_TX_EN 'TX_EN
		WYPIN ##$FFFF, #pin_TX0 'channel 0 is all 1's (part of the preamble)
		WYPIN ##$8000, #pin_TX1 'this is the 1 that designates the start of frame

nexTX			
		RFLONG dwTX'fetch 4 bytes to send
		MOVBYTS dwTX, #%00_01_10_11 'reverse bytewise	

		REV dwTX		
		SETQ dwTX 'for crc
		REV dwTX

		REP #1, #8 '32 bits == 8 nibbles
		CRCNIB CRC_TX, CRC_Poly	
				
		SPLITW dwTX	'distribute the data amongst the two smartpins
		GETWORD wTX0, dwTX, #0
		GETWORD wTX1, dwTX, #1		

		WAITSE1 'wait until buffer is free
		WYPIN ##-1, #pin_TX_EN 'TX_EN is high
		WYPIN wTX0, #pin_TX0
		WYPIN wTX1, #pin_TX1
			
		
djnz	ct, #nexTX

sendcrc

		'REV CRC_TX
		'NOT	CRC_TX
		'mov CRC_TX, #1
		'REV CRC_TX
		MOVBYTS CRC_TX, #%00_01_10_11 'reverse bytewise	
		
		SPLITW CRC_TX	'distribute the data amongst the two smartpins
		GETWORD wTX0, CRC_TX, #0
		GETWORD wTX1, CRC_TX, #1		

		WAITSE1 'wait until buffer is free
		WYPIN ##-1, #pin_TX_EN 'TX_EN is high
		WYPIN wTX0, #pin_TX0
		WYPIN wTX1, #pin_TX1

		WAITSE1 'wait until buffer is free

		WYPIN #0, #pin_TX_EN 'finito
		WYPIN #0, #pin_TX0
		WYPIN #0, #pin_TX1
		
		WAITSE1 'wait for line to go down and we are done
		
		DIRL #pin_TX_EN + (2 << 6)' stop 3 smartpins
		
		DRVH #pin_SIG'trigger
		DRVL #pin_SIG'scope
jmp #go
		


		


DAT ORG


ETHERNET_RX 	


		'events
		SETSE1  #%110<<6 + pin_CRS	'CRS IS HIGH
  		SETSE2  #%001<<6 + pin_RX0	'RX'd one word
  		SETSE3  #%100<<6 + pin_CRS	'CRS IS LOW
	 	
	 	'the two smartpins sample ODD and EVEN data bits of the RMII
  		WRPIN  ##P_MINUS1_B	| P_SYNC_RX	| P_HIGH_15K, #pin_RX0
		WRPIN  ##P_MINUS2_B	| P_SYNC_RX	| P_HIGH_15K, #pin_RX1
		
		'sample the CRS line to know the frame size
		WRPIN  ##P_PLUS3_A	| P_SYNC_RX  , #pin_CLK '| P_INVERT_B	
				
		'CRS_DV has CRS and RX_DV signal in one, sampled on alternative clock cycles
		'that means the CRS_DV signal will toggle at the end of packet on some PHYs
				
		WRPIN	##P_HIGH_15K, #pin_CRS ' PULLUPS for MODE 2:0 selection on PHY
	

		
arm_smartpins

		DIRL #pin_CLK + (2 << 6) 'RESET smartpins CLK & RX0 & RX1

		WRPIN  #P_REPOSITORY	, #pin_RX1 'prime this smartpin with 0s...
		WXPIN  #0					, #pin_RX1 '...save an AND later
		WRPIN  ##P_MINUS2_B	| P_SYNC_RX	, #pin_RX1 'restore operation
		
		WXPIN	#%1_00111 ,	#pin_CLK + (2 << 6) 'set data width to 8 bit for CLK, RX0, RX1
		 		
  		mov CRC, ##-1
		WRFAST 	#24, PTRA 'prepare FIFO, wrap after 24*64=1536 bytes
		
		
		'mov N, #0
		
		
		mov ADDR, PTRA
		ADD ADDR, ##bufflongs*4

okgo	RDLONG L, ADDR
		OR	L, #0 WZ 'wait for HUB to be READY
if_NZ	jmp #okgo	
		
await_packet 'wait for new packet
		MODZ _CLR WZ ' Z FLAG will signal the end of data reception
		MOV	loops, (1524>> 2) 'prepare counter. biggest frame is 1520 bytes + 4 bytes FCS
		'this needs to be watched carefully, also the FIFO block size should match

  		POLLSE2	'clear byte event
  'tidy this up, get rid of events, or use a PIN FILTER (dunno how)	
	'shift in and count 1s (start with 0)	
		POLLSE3 'clear packet end event
		WAITSE3 'make sure line is clear, no transmission
		
		POLLSE1	'clear packet start event			
		WAITSE1 'wait for CRS to go UP (packet start)
		
		POLLSE3 'clear packet end event again
		
		'to be sure we must sample a number of times the CRS pin ( say 10 clocks )
		'since it might be toggling
		

rx_packet 'start receiving

		'now the preamble is live (10101010101...11)
		'...111111111111
		'...000000000001 as seen on the scope (channels 1 and 0)
		'			   ° this is the ONE we're looking for
	
	'	DRVH #pin_SIG'trigger
	'	DRVL #pin_SIG'scope	

		DIRH ##pin_CLK + (2 << 6) 'start smartpins CLK & RX0 & RX1			
first_byte 
		'we have 8 bits time to update the X registers
		
c1		WAITSE2 'wait for 8 bits to arrive (that is really 2*8 bits)
	
c2 		AKPIN #pin_CLK + (1 << 6)'keep CLK + RX0 smartpin working and shifting	
 	
c3 		RDPIN rxb1, #pin_RX1 'data is shifted in from the left

c4		REV rxb1 'orient to the right
c5		ENCOD rxb1 WC 'count bits after first '1'

c6		if_nc jmp #first_byte 'if no '1' is in the shifter, try again

c7		SUBR rxb1, #%1_01111 'how many bits are missing to have 16? (-1)
c8		WXPIN	rxb1 , #pin_CLK + (2 << 6) 'set CLK's, RX0's and RX1's width to #bits
							  ' + (addpin2)
 		
		WAITSE2 'wait until first word of data is complete
			
		'16 good bits are in each smartpin		
		WXPIN	#%1_01111 , #pin_CLK + (2 << 6) 'from now on always fetch 16(*2) bits

RXloop
	'	JSE3 #EOF 'Triggers once frame is through
comeagain
					
		RDPIN rxb1, #pin_RX1 'let's finally fetch our data
		RDPIN rxb0, #pin_RX0
		RDPIN frame, #pin_CLK
		TESTBN frame, #31 WZ 'is this the last /or even empty/ word?
		AND frame, ##$AAAA0000
		ONES frame 'count ones
		'we can now shift it right and count the bits = halfnibbles
		wflong frame
		
		'take upper half of each smartpin and mix them together
		GETWORD rxb1, rxb1, #1 '0000aaaa
		ROLWORD rxb1, rxb0, #1 'aaaabbbb<<<<
		MERGEW rxb1 'do the shuffle: D = a15, b15, a14, b14, .... a1,b1,a0,b0
		
		REV rxb1
		SETQ rxb1 'for crc
		REV rxb1
		
		MOVBYTS rxb1, #%00_01_10_11 'reverse bytewise
		wflong rxb1 'write out word to ::: FIFO :::
		'wflong CRC
		add N, #1

if_Z	JMP #finish	'flag previously set, did signal frame end?

		REP #1, #8 '32 bits == 8 nibbles
		CRCNIB CRC, CRC_Poly
								
		WAITSE2 'wait for next 16 (*2) bits
		
again		DJNZ	loops, #RXloop

'if the loop finishes, the packet was too long

		JMP #BADframe

EOF		'we land here once CRS is low
		RDPIN CTrx, #pin_CLK ' save bit counter value
		MODZ _SET WZ ' make loop end before final CRC calculation
		JMP #comeagain 'back to the loop
		


finish	'start calculating the number of bytes that still need CRCing
		'CTrx holds the number of clocks between CRS going low and the smartpins finishing
'		SHR	CTrx, #2 'divide by 4, get number of invalid bytes
'		SUBR CTrx,#4 'get number of valid bytes (4-x)
'		SHL frame, #1 WZ'number of valid nibbles
		AND frame, #15 WZ 'it should not be more than 8. if 0: skip REP



if_nz	REP #1, frame 'prevent 0 as parameter because that means an endless loop
if_nz	CRCNIB CRC, CRC_Poly 'let it roll

		not CRC		'it should now be 0x2144DF1C (verify value)
		sub CRC, ##$2144DF1C WZ 'Z flag: CRC is OK

if_z		ADD good, #1
if_z		SKIP #1
BADframe
		ADD bad, #1

		GETPTR blub 'where is the FIFO pointing at?
		SUB blub, PTRA	'what we should do is check for wrapping (limit set above)
		ADD N, blub
			
		mov ADDR, PTRA
		ADD ADDR, ##bufflongs*4
		WRFAST 	#24, ADDR
NOP
NOP

'start dissecting packet



		wflong N
		wflong bad
		wflong good			
		wflong CRC'CTrx
		wflong blub
			
			
		JMP	#arm_smartpins
  		
  			bogo long 0
  			l	long	0
			blub long 0
			addr long 0
			frame long 0	'save CRS signal here
			loops long 0
			CTrx long 0
			rxb0 long 0	'receive buffer odd bits	0..
			rxb1 long 0	'receive buffer even bits	..1..
			good long 0
			bad long 0
			N long 0
			CRC long 0
			CRC_Poly long $edb88320 '$4c11db7
  			   
  			   
TX
	'FIFO for packet dissection
	'setQ fastread to copy 8 words or so at a time
	
	
'(the following is an EXCERPT FROM WIKIPEDIA, https://en.wikipedia.org/wiki/Ethernet_frame)	
	
'Per the standard, this computation is done using the left shifting CRC32 BZIP2 
'(poly = 0x4C11DB7, initial CRC = 0xFFFFFFFF, CRC is post complemented, 
'verify value = 0x38FB2284) algorithm.
'The standard states that data is transmitted least significant bit (bit 0) first
', while the FCS is transmitted most significant bit (bit 31) first.
'[3]: section 3.2.9  An alternative is to calculate a CRC using the right shifting 
'CRC32 (poly = 0xEDB88320, initial CRC = 0xFFFFFFFF, CRC is post complemented, 
'verify value = 0x2144DF1C), which will result in a CRC that is a bit reversal 
'of the FCS, and transmit both data and the CRC least significant bit first, 
'resulting in identical transmissions.
